package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.components.EditBox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.Minecraft;

import net.mcreator.puzzle_code.world.inventory.CustomEffectBlockGUIMenu;
import net.mcreator.puzzle_code.procedures.ReturnEffectNBTProcedure;
import net.mcreator.puzzle_code.network.CustomEffectBlockGUIButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class CustomEffectBlockGUIScreen extends AbstractContainerScreen<CustomEffectBlockGUIMenu> {
	private final static HashMap<String, Object> guistate = CustomEffectBlockGUIMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	EditBox effectField;
	Button button_1;
	Button button_2;
	Button button_3;
	Button button_4;
	ImageButton imagebutton_enter_button;
	ImageButton imagebutton_edit_button;
	ImageButton imagebutton_question_mark_button;

	public CustomEffectBlockGUIScreen(CustomEffectBlockGUIMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 86;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("puzzle_code:textures/screens/custom_effect_block_gui.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		effectField.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
		if (mouseX > leftPos + 6 && mouseX < leftPos + 26 && mouseY > topPos + 30 && mouseY < topPos + 50)
			guiGraphics.renderTooltip(font, Component.translatable("gui.puzzle_code.custom_effect_block_gui.tooltip_nbt_effect"), mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		if (effectField.isFocused())
			return effectField.keyPressed(key, b, c);
		return super.keyPressed(key, b, c);
	}

	@Override
	public void resize(Minecraft minecraft, int width, int height) {
		String effectFieldValue = effectField.getValue();
		super.resize(minecraft, width, height);
		effectField.setValue(effectFieldValue);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font,

				ReturnEffectNBTProcedure.execute(world, x, y, z), 33, 35, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		effectField = new EditBox(this.font, this.leftPos + 7, this.topPos + 9, 118, 18, Component.translatable("gui.puzzle_code.custom_effect_block_gui.effectField"));
		effectField.setMaxLength(32767);
		guistate.put("text:effectField", effectField);
		this.addWidget(this.effectField);
		button_1 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui.button_1"), e -> {
		}).bounds(this.leftPos + 6, this.topPos + 57, 18, 20).build();
		guistate.put("button:button_1", button_1);
		this.addRenderableWidget(button_1);
		button_2 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui.button_2"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUIButtonMessage(1, x, y, z));
				CustomEffectBlockGUIButtonMessage.handleButtonAction(entity, 1, x, y, z);
			}
		}).bounds(this.leftPos + 56, this.topPos + 57, 18, 20).build();
		guistate.put("button:button_2", button_2);
		this.addRenderableWidget(button_2);
		button_3 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui.button_3"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUIButtonMessage(2, x, y, z));
				CustomEffectBlockGUIButtonMessage.handleButtonAction(entity, 2, x, y, z);
			}
		}).bounds(this.leftPos + 105, this.topPos + 57, 18, 20).build();
		guistate.put("button:button_3", button_3);
		this.addRenderableWidget(button_3);
		button_4 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui.button_4"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUIButtonMessage(3, x, y, z));
				CustomEffectBlockGUIButtonMessage.handleButtonAction(entity, 3, x, y, z);
			}
		}).bounds(this.leftPos + 150, this.topPos + 57, 18, 20).build();
		guistate.put("button:button_4", button_4);
		this.addRenderableWidget(button_4);
		imagebutton_enter_button = new ImageButton(this.leftPos + 150, this.topPos + 8, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/enter_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/enter_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new CustomEffectBlockGUIButtonMessage(4, x, y, z));
						CustomEffectBlockGUIButtonMessage.handleButtonAction(entity, 4, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_enter_button", imagebutton_enter_button);
		this.addRenderableWidget(imagebutton_enter_button);
		imagebutton_edit_button = new ImageButton(this.leftPos + 128, this.topPos + 8, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/edit_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/edit_button_hovered.png")), e -> {
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_edit_button", imagebutton_edit_button);
		this.addRenderableWidget(imagebutton_edit_button);
		imagebutton_question_mark_button = new ImageButton(this.leftPos + 6, this.topPos + 30, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button_highlight.png")), e -> {
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_question_mark_button", imagebutton_question_mark_button);
		this.addRenderableWidget(imagebutton_question_mark_button);
	}
}
